$Swol::DWandModeText[0] = "\c0Destroy Mode";
$Swol::DWandModeText[1] = "\c3Clear Mode";

adminWandImage.lightType = "ConstantLight";
adminWandImage.hasLight    = true;
adminWandImage.lightRadius = 8.0;
adminWandImage.lightColor  = "1 0.65 0";
package Swol_DWandPlus
{
	function adminWandImage::onMount(%this,%obj,%slot)
	{
		%cl = %obj.client;
		if(!%cl.isAdmin)
		return;
		%cl.dWandMode = 0;
		
		%cl.destructoWandMode = 0;
		%cl.destructoWandLoop();
		
		parent::onMount(%this,%obj,%slot);
		bottomPrint(%cl,"");
	}
	function adminWandImage::onFire(%this,%obj,%slot)
	{
		%cl = %obj.client;
		if(!%cl.isAdmin)
		return;
		
		if(%cl.dWandMode)
		{
			%cl.dWandClearBricks();
			return;
		}
		
		parent::onFire(%this,%obj,%slot);
	}
	function GameConnection::dWandClearBricks(%cl)
	{
		if(!isObject(%cl.player))
		return;
		
		%pl = %cl.player;

		%eye = vectorScale(%pl.getEyeVector(), 300);
		%pos = %pl.getEyePoint();
		%mask = $TypeMasks::FxBrickObjectType | $TypeMasks::FxBrickAlwaysObjectType;
		%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %pl));
		
		if(!isObject(%hit))
		return resetDwandClear(%cl);
		
		if(%hit.getClassName() $= "fxDTSBrick")
		{
			confirmDwandClear(%cl,%hit);
		}
	}
	function confirmDwandClear(%cl,%brick)
	{
		if(!%cl.confirmingDwandClear)
		{
			if(%brick.getGroup().bl_id == 888888)
			{
				if(!%cl.isSuperAdmin)
				return;
				if(%cl.destroyPublicBricks != 1)
				return;
			}
			%ownerN = %brick.getGroup().name;
			%cl.confirmingDwandClear = 1;
			%cl.confirmBrickGroup = %brick.getGroup();
			if(%brick.getGroup().bl_id == 888888)
			centerPrint(%cl,"<font:impact:50>\c3/\c0!\c3\\ \c0Are you sure you would like to clear ALL of the \c6public bricks? \c3/\c0!\c3\\",3);
			else
			centerPrint(%cl,"<font:impact:50>\c0Are you sure you would like to clear ALL of \c6" @ %ownerN @ "'s\c0 bricks?",3);
			
			%cl.dWandClearSched = schedule(3000,0,resetDwandClear,%cl);
		}
		else
		{
			if(%brick.getGroup().bl_id == 888888)
			{
				if(!%cl.isSuperAdmin)
				return;
				if(%cl.destroyPublicBricks != 1)
				return;
			}
			
			if(%cl.confirmBrickGroup != %brick.getGroup())
			{
				resetDwandClear(%cl);
				return;
			}
			%brickGroup = %brick.getGroup();
			for(%i = 0;%i<%brickGroup.getCount();%i++)
			{
				%brick = %brickGroup.getObject(%i);
				%brick.killBrick();
			}
			%ownerN = %brick.getGroup().name;
			if(%brick.getGroup().bl_id == 888888)
			MessageAll('MsgClearBricks',"\c3" @ %cl.name @ "\c0 cleared all \c6public \c0bricks.");
			else
			MessageAll('MsgClearBricks',"\c3" @ %cl.name @ "\c0 cleared \c3" @ %ownerN @ "'s\c0 bricks.");
			resetDwandClear(%cl);
		}
	}
	function resetDwandClear(%cl)
	{
		cancel(%cl.dWandClearSched);
		%cl.confirmBrickGroup = 0;
		%cl.confirmingDwandClear = 0;
		%cl.destructoWandLoop();
	}
	function GameConnection::destructoWandLoop(%cl)
	{
		cancel(%cl.destructoWandSched);
		if(!isObject(%cl.player))
		return;
		
		%pl = %cl.player;
		
		if(%pl.getMountedImage(0) != adminWandImage.getID())
		return;
		
		%cl.destructoWandSched = %cl.schedule(100,destructoWandLoop);
		
		%eye = vectorScale(%pl.getEyeVector(), 300);
		%pos = %pl.getEyePoint();
		%mask = $TypeMasks::PlayerObjectType | $TypeMasks::FxBrickObjectType;
		%hit = firstWord(containerRaycast(%pos, vectorAdd(%pos, %eye), %mask, %pl));
		
		bottomPrint(%cl,"\c6Destructo Wand Mode: \c3" @ $Swol::DWandModeText[%cl.dWandMode] @ "<br>\c6Destroy Public Bricks: " @ (%cl.destroyPublicBricks ? "\c0ON" : "\c2OFF" ),1);
		
		if(!isObject(%hit))
		return;
		
		if(%hit.getClassName() $= "Player")
		{
			displayStats(%cl,%hit.client,0);
		}
		if(%hit.getClassName() $= "fxDTSBrick" && !%cl.confirmingDwandClear)
		{
			displayDWandStats(%cl,%hit);
		}
	}
	function GameConnection::changeDWandMode(%cl)
	{
		%cl.dWandMode++;
		if(%cl.dWandMode > 1)
		{
			%cl.dWandMode = 0;
		}
		%cl.destructoWandLoop();
	}
	function displayDWandStats(%cl,%brick)
	{
		%cl.wasGazingDWand = 1;
		%ownerN = %brick.getGroup().name;
		%bl_id = %brick.getGroup().bl_id;
		centerPrint(%cl,"<just:right><font:impact:30>\c0Owner: \c6" @ %ownerN @ " <br><font:impact:20>\c4BLID: " @ %bl_id @ " ",1);
	}
	function serverCmdLight(%cl)
	{
		if(!isObject(%cl.player))
		return;
		%pl = %cl.player;
		if(%pl.getMountedImage(0) == adminWandImage.getID())
		{
			%cl.changeDWandMode();
			return;
		}
		
		parent::serverCmdLight(%cl);
	}
};
ActivatePackage(Swol_DwandPlus);